#include <stdint.h>
#include "colour.h"




void hsl2rgb(hsl_t *s, rgb_t *d) {
  uint8_t inverse_sat = (s->s ^ 255);
  uint8_t r_temp, g_temp, b_temp;
  //uint8_t hue_mod=3*(s->h%86);// same performance as hue & 0xff
  //if(s->h)
  if (s->h < 86) {
	  r_temp = (3*s->h) ^ 255;//hue_mod ^ 255;
	  g_temp = 3*s->h;//hue_mod;
	  b_temp = 0;
  } else if (s->h < 172) {
    r_temp = 0;
    g_temp = (3*(s->h-86))^255;//hue_mod ^ 255;
    b_temp = 3*(s->h-86);//hue_mod;
  } else {
	  r_temp = 3*(s->h-172);//hue_mod;
	  g_temp = 0;
	  b_temp = (3*(s->h-172))^255;//hue_mod ^ 255;
  }
  d->r = r_temp;
  d->g = g_temp;
  d->b = b_temp;
  for (int i = 0; i < 3; ++i) {
    uint8_t t8 = ((uint8_t*)d)[i];
    uint16_t t16 = t8 * s->s;
    t16 = t16 + t8; // Instead of * (sat+1)
    t8 = t16 >>8;
    t8 = t8 + inverse_sat;
    t16 = t8 * s->l;
    t16 = t16 + t8; // Instead of * (lum+1)
    t8 = t16>>8;
    ((uint8_t*)d)[i] = t8;
  }
}

