#include "defines.h"
#include "ledBuffer.h"


rgb_t ledBuffer[NUM_LEDS];
int randNum=0x8789;

const unsigned int ledOrder[] = {FLEUR1_LED,PAP1_LED2,PAP1_LED1,FLEUR2_LED,
								 PAP2_LED2, PAP2_LED1,POMPON_LED}; 

void clrData(){
  int i;
  char* p = (char*)ledBuffer;
  for( i = 0; i < sizeof(ledBuffer); i++)
    *p++ = 0;
}

void clrPixel(int pixel){
  char* p = (char*)&ledBuffer[pixel];
  *p++ = 0;
  *p++ = 0;
  *p++ = 0;
  // clear r,g,b;
}

// shifts pixels to the right
void shiftPixelsR(){
  rgb_t temp;
  temp = ledBuffer[NUM_LEDS-1];
  int i;
  for(i=NUM_LEDS-1;i>0;i--)
    ledBuffer[i] = ledBuffer[i-1];
  ledBuffer[0] = temp;
}

// shifts pixels to the left
void shiftPixelsL(){
  rgb_t temp;
  temp = ledBuffer[0];
  int i;
  for(i=0;i<NUM_LEDS-1;i++)
    ledBuffer[i] = ledBuffer[i+1];
  ledBuffer[NUM_LEDS-1] = temp;
}


unsigned int rand()
{
  unsigned int temp,i;
  for(i=0;i<16;i++){
    temp = ((((randNum&0x8000)>>15) ^ ((randNum&0x2000)>>13)) ^ ((randNum&0x1000)>>12)) ^ ((randNum&0x800)>>10);
    randNum = (randNum<<1) | (temp & 1);
  }
  return randNum;
}
